%define scm_version 5d1
%define slib_version 2c6

Summary: scheme library and scheme interpreter
Name: scm-slib
Version: %{scm_version}
Release: 1 
Copyright: GPL
Group: Development/Languages/Scheme
Source: ftp://ftp-swiss.ai.mit.edu/pub/scm/scm%{scm_version}.zip
Source1: ftp://ftp-swiss.ai.mit.edu/pub/scm/slib%{slib_version}.zip
Source2: ftp://ftp-swiss.ai.mit.edu/pub/scheme-reports/r5rs.tar.gz
Source3: ftp://ftp-swiss.ai.mit.edu/pub/scheme-reports/rrrs2txi.scm
Patch: scm-5d0-texi.patch
Patch1: scm-slib-5d0-rrrs2txi.diff
Patch2: slib-2c5-texi.patch
Patch3: scm-5d1-xgen.patch
BuildRoot: /var/tmp/%{name}-%{version}

%description
Scm is a portable Scheme implementation written in C.
SLIB is a portable scheme library meant to provide compatibility and
utility functions for all standard scheme implementations.
Both conform to Revised^5 Report on the Algorithmic Language Scheme
and the IEEE P1178 specification.

%package -n slib
Summary: portable scheme library
Version: %{slib_version}
Group: Development/Languages/Scheme
URL: http://swissnet.ai.mit.edu/~jaffer/SLIB.html

%description -n slib
SLIB is a portable scheme library meant to provide compatibility and
utility functions for all standard scheme implementations.
It conforms to Revised^5 Report on the Algorithmic Language Scheme
and the IEEE P1178 specification.

%package -n scm
Summary: scm scheme implementation
Version: %{scm_version}
Group: Development/Languages/Scheme
URL: http://swissnet.ai.mit.edu/~jaffer/SCM.html
Requires: slib >= 2c3

%description -n scm
Scm is a portable Scheme implementation written in C.
It conforms to Revised^5 Report on the Algorithmic Language Scheme
and the IEEE P1178 specification.

%changelog

* Wed Oct 6 1999 W. L. Estes <will@fumblers.org>
- scm 5d1, slib 2c6
- rewrite %%prep to handle new zip file packaging
- rewrite texinfo patches
- export variables at the top of %%build
- which means we rewrite the sed commands at the bottom of %%build
- use rpm3 style macros
- recode install-info handling 
  (note that install-info should be in your path; redhat continues to
  ship install-info in /sbin. that's a bug in *their* package, not in
  this one.)
- add Xlibscm to info file handling

* Sun Jun 27 1999 W. L. Estes <will@fumblers.org>
- use original r5rs latex sources
- patch rrrs2txi for xrefs
- edit slibcat and implcat to reflect the install environment
- thanks to Alex Stark <stark@niss.org> and Jos Romildo Malaquias
  <romildo@urano.iceb.ufop.br> for reporting problems with the previous packaging

* Tue Mar 02 1999 W. L. Estes <wlestes@tarvalon.uncg.edu>
- use %%define prefix
- require slib >= 2c3
- drop patch to r5rs.txi, let the sections go as is
- drop html/texi docs
- patch scm.texi, slib.texi, r5rs.txi  for cross refs and typos

* Fri Feb 23 1999 Jos Romildo Malaquias <romildo@iceb.ufop.br>
- initial build integrating slib and scm

%prep
%setup -q -T -c -a2
unzip -q %SOURCE0
unzip -q %SOURCE1
cp %SOURCE3 .
%patch -p0 -b .orig
%patch1 -p0 -b .orig
%patch2 -p0 -b .orig
%patch3 -p0 -b .orig

%build
SCHEME_LIBRARY_PATH=`pwd`/slib/
SCM_INIT_PATH=`pwd`/scm/Init%{scm_version}.scm
export SCM_INIT_PATH SCHEME_LIBRARY_PATH

( cd scm
    make scmlit
    ./scmlit -f build -e'(bi)' build > makescm
    . ./makescm
    #lifted from Makefile
    ./scmlit -r database-browse -l build.scm -e "(browse build 'platform)" > platform.txi
    make version.txi
    makeinfo scm.texi
    cd ..
    scm/scm -lrrrs2txi -e '(go)'
    makeinfo r5rs.txi
)

( cd slib
    make version.txi
    PATH="../scm:$PATH" make htmlform.txi
    makeinfo slib.texi
)

( cd scm
    sed \
	-e "s:$SCHEME_LIBRARY_PATH:%_usr/share/slib/:" \
	-e "s:$SCM_INIT_PATH:%_usr/share/scm/Init%{scm_version}.scm:" \
	slibcat > slibcat.tmp
    mv slibcat.tmp slibcat
    sed \
	-e "s:`pwd`:%_usr/share/scm:" \
	implcat > implcat.tmp
    mv implcat.tmp implcat
)

cat > slib.sh << EOF
SCHEME_LIBRARY_PATH=%_usr/share/slib/
export SCHEME_LIBRARY_PATH
EOF
chmod 755 slib.sh

cat > scm.sh << EOF
SCM_INIT_PATH=%_usr/share/scm/Init%{scm_version}.scm
export SCM_INIT_PATH
EOF
chmod 755 scm.sh

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{usr/{man,info,bin,share/{slib,scm}},etc/profile.d}

( cd slib
    cp -p *.scm *.init *.pat *.sh $RPM_BUILD_ROOT/usr/share/slib
    gzip --name *.info*
    cp -p slib.info* $RPM_BUILD_ROOT/usr/info
)

( cd scm
    make install prefix=$RPM_BUILD_ROOT/usr/ IMPLPATH=$RPM_BUILD_ROOT/usr/share/scm/
    cp -pf *.scm pi.c implcat slibcat $RPM_BUILD_ROOT/usr/share/scm
    cp -pf .gdbinit $RPM_BUILD_ROOT/usr/share/scm
    gzip --name *.info*
    cp -p *.info* $RPM_BUILD_ROOT/usr/info
)

cp -p *.sh $RPM_BUILD_ROOT/etc/profile.d
gzip --name r5rs.info*
cp -p r5rs.info*.gz $RPM_BUILD_ROOT/usr/info

%clean
rm -rf $RPM_BUILD_ROOT

%post -n slib
for i in --delete " " ; do
    install-info $i %_usr/info/slib.info.gz %_usr/info/dir
done

%preun -n slib
if [ $1 = 0 ] ; then
    install-info --delete %_usr/info/slib.info.gz %_usr/info/dir
fi

%post -n scm
for j in --delete " " ; do
    for i in Xlibscm r5rs scm ; do
    install-info $j %_usr/info/$i.info.gz %_usr/info/dir
    done
done

%preun -n scm
if [ $1 = 0 ] ; then
    for i in Xlibscm scm r5rs ; do
    install-info --delete %_usr/info/$i.info.gz %_usr/info/dir
    done
fi

%files -n slib
%defattr (-, root, root)
%doc slib/ANNOUNCE slib/FAQ slib/README
/etc/profile.d/slib.sh
%_usr/info/slib.info*.gz
%_usr/share/slib

%files -n scm
%defattr (-, root, root)
%doc scm/QUICKREF scm/README scm/ANNOUNCE
/etc/profile.d/scm.sh
%_usr/bin/*
%_usr/info/Xlibscm.info*.gz
%_usr/info/r5rs.info*.gz
%_usr/info/scm.info*.gz
%_usr/man/*/*
%_usr/share/scm
